fun days2ms days =
  let
    val hours = days * 24.0
    val minutes = hours * 60.0
    val seconds = minutes * 60.0
  in
    seconds * 1000.0
  end;



fun fact n =
      if (n = 0) then
        1
      else
        let
          val b = fact (n-1)
        in
          n * b
        end;



fun halve nil = (nil, nil)
 |  halve [a] = ([a], nil)
 |  halve (a::b::cs) =
      let
        val (x,y) = halve cs
      in
        (a::x, b::y)
      end;



fun quicksort nil = nil
 |  quicksort (pivot::rest) =
      let
        fun split(nil) = (nil,nil) (* a nested function *)
         |  split(x::xs) =
              let
                val (below, above) = split(xs)
              in
                 if x < pivot then   (* pivot is a non-local reference *)
                   (x::below, above)
                 else
                   (below, x::above)
              end;
        val (below, above) = split(rest) (* call the nested function split *)
      in
        quicksort below @ [pivot] @ quicksort above
      end;



fun AddXToY (x, y) =
  let
    fun addX y =        (* a nested function *)
      y + x             (* x is a non-local reference *)
    in
      addX y            (* call the nested function *)
    end;


fun AddXToAll (x, theList) =
  let
    fun addX y =        (* a nested function *)
      y + x             (* x is a non-local reference *)
    in
      map addX theList  (* pass the nested function as an arg to map *)
    end;


fun funToAddX x =
  let
    fun addX y =        (* a nested function *)
      y + x             (* x is a non-local reference *)
    in
      addX              (* return the nested function *)
    end;